#include "testApp.h"

//--------------------------------------------------------------
void testApp::setup(){
	ofSetWindowTitle("Moving Vertex by Media Lab Helsinki");
	ofBackground(0, 0, 0);
	ofEnableSmoothing();
	ofSetBackgroundAuto(false);
	for (int i=0; i<numShapes; i++) {
		vertexShape[i].x1=300+i;
		vertexShape[i].y1=300+i;
		vertexShape[i].x2=600-i;
		vertexShape[i].y2=400-i;
		vertexShape[i].speedX1=ofRandomf();
		vertexShape[i].speedY1=ofRandomf();
		vertexShape[i].speedX2=ofRandomf();
		vertexShape[i].speedY2=ofRandomf();
	}
	ofSetFrameRate(100);
}

//--------------------------------------------------------------
void testApp::update(){
	for (int i=0; i<numShapes; i++) {
		vertexShape[i].x1+=vertexShape[i].speedX1;
		vertexShape[i].y1+=vertexShape[i].speedY1;
		vertexShape[i].x2+=vertexShape[i].speedX2;
		vertexShape[i].y2+=vertexShape[i].speedY2;
		if(vertexShape[i].x1<0 ||vertexShape[i].x1>ofGetWidth()){
			vertexShape[i].speedX1*=-1;
		}
		if(vertexShape[i].x2<0 ||vertexShape[i].x2>ofGetWidth()){
			vertexShape[i].speedX2*=-1;
		}
		if(vertexShape[i].y1<0 ||vertexShape[i].y1>ofGetHeight()){
			vertexShape[i].speedY1*=-1;
		}
		if(vertexShape[i].y2<0 ||vertexShape[i].y2>ofGetHeight()){
			vertexShape[i].speedY2*=-1;
		}
	}
}

//--------------------------------------------------------------
void testApp::draw(){
	for (int i=0; i<numShapes; i++) {
		ofSetColor((ofGetFrameNum()/4)%200,0,i+50);
		//ofLine(vertexShape[i].x1, vertexShape[i].y1, vertexShape[i].x2, vertexShape[i].y2);
		float mouseFxX = (mouseX-ofGetWidth()/2)/5;
		float mouseFxY = (mouseY-ofGetHeight()/2)/5;
		float middleX = (vertexShape[i].x1+vertexShape[i].x2)/2+mouseFxX;
		float middleY = (vertexShape[i].y1+vertexShape[i].y2)/2+mouseFxY;
		ofNoFill();
		ofBeginShape();
		ofVertex(vertexShape[i].x1,vertexShape[i].y1);
		ofBezierVertex(vertexShape[i].x1, vertexShape[i].y1, middleX, middleY, 
					   vertexShape[i].x2, vertexShape[i].y2);
		ofEndShape();
	}
}

//--------------------------------------------------------------
void testApp::keyPressed(int key){
	if (key == 'p') {
		string dateStamp = "_"+ofToString(ofGetYear())+"-"+ofToString(ofGetMonth())+"-"+ofToString(ofGetDay())+"_"+ofToString(ofGetHours())+"-"+ofToString(ofGetMinutes())+"_"+ofToString(ofGetSeconds());
		ofSaveScreen("screenshot"+dateStamp+".png");
	}		
	if (key == OF_KEY_BACKSPACE) {
		setup();
	}		
}

//--------------------------------------------------------------
void testApp::keyReleased(int key){

}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){

}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){

}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){

}

//--------------------------------------------------------------
void testApp::mouseReleased(int x, int y, int button){

}

//--------------------------------------------------------------
void testApp::windowResized(int w, int h){

}

